/************************************************************** /
                      Made by : Mr. Sottong
                      NTP CLock V2.0
****************************************************************/

#include <ESP8266WiFi.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include "Ticker.h"

Ticker Timer500ms;

// Replace with your network credentials
const char *ssid     = "ElisaCom_Kos";
const char *password = "kosElisa12345";

// Define NTP Client to get time
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org");

//OTHER variables................................................................
//Pin connected to ST_CP / Pin 12 of 74HC595
int latchPin = 0; //D3 
//Pin connected to SH_CP / Pin 11 of 74HC595
int clockPin = 5; //D1
////Pin connected to DS / Pin 14 of 74HC595
int dataPin = 4; //D2
//Pin connected to LEDup
int LEDup = 13;  //D7
//Pin connected to LEDdown
int LEDdn = 12;  //D6

//Week Days
int weekDays;

//Month names
int months;

//Seven Segment
unsigned long d1[10] = {0x0380,0x9f80,0x2580,0x0d80,0x9980,0x4980,0x4180,0x1f80,0x0180,0x0980};
unsigned long d2[10] = {0x0240,0x9e40,0x2440,0x0c40,0x9840,0x4840,0x4040,0x1e40,0x0040,0x0840};
unsigned long d3[10] = {0x0320,0x9f20,0x2520,0x0d20,0x9920,0x4920,0x4120,0x1f20,0x0120,0x0920};
unsigned long d4[10] = {0x0310,0x9f10,0x2510,0x0d10,0x9910,0x4910,0x4110,0x1f10,0x0110,0x0910};
unsigned long d5[10] = {0x0308,0x9f08,0x2508,0x0d08,0x9908,0x4908,0x4108,0x1f08,0x0108,0x0908};
unsigned long d6[10] = {0x0304,0x9f04,0x2504,0x0d04,0x9904,0x4904,0x4104,0x1f04,0x0104,0x0904};
unsigned long d7[10] = {0x0302,0x9f02,0x2502,0x0d02,0x9902,0x4902,0x4102,0x1f02,0x0102,0x0902};
unsigned long d8[10] = {0x0301,0x9f01,0x2501,0x0d01,0x9901,0x4901,0x4101,0x1f01,0x0101,0x0901};

bool Led = 0;

void printDigits(int value, int value2) {

  int th = value / 1000;
  int hun = value / 100;
  int tens = value / 10;
Serial.println(value);
Serial.println(value2);

  digitalWrite(latchPin, LOW);  //THOUSANDS - Ribuan - jam
  shiftOut(dataPin, clockPin, LSBFIRST, d1[th]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d1[th]>>8); 
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //HUNDREDS - Ratusan - jam
  shiftOut(dataPin, clockPin, LSBFIRST, d2[hun % 10]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d2[hun % 10]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //TENS - Puluhan - menit
  shiftOut(dataPin, clockPin, LSBFIRST, d3[tens % 10]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d3[tens % 10]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //ONES - satuan - menit
  shiftOut(dataPin, clockPin, LSBFIRST, d4[(value % 10)]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d4[(value % 10)]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);

  int th2 = value2 / 1000;
  int hun2 = value2 / 100;
  int tens2 = value2 / 10;

    digitalWrite(latchPin, LOW);  //THOUSANDS - Ribuan - jam
  shiftOut(dataPin, clockPin, LSBFIRST, d5[th2]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d5[th2]>>8); 
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //HUNDREDS - Ratusan - jam
  shiftOut(dataPin, clockPin, LSBFIRST, d6[hun2 % 10]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d6[hun2 % 10]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //TENS - Puluhan - menit
  shiftOut(dataPin, clockPin, LSBFIRST, d7[tens2 % 10]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d7[tens2 % 10]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);

  digitalWrite(latchPin, LOW);  //ONES - satuan - menit
  shiftOut(dataPin, clockPin, LSBFIRST, d8[(value2 % 10)]); 
  shiftOut(dataPin, clockPin, LSBFIRST, d8[(value2 % 10)]>>8);
  digitalWrite(latchPin, HIGH);
  delay(1);
}

void wifinc(){

//animation when wifi is not connected

int on = 0b0000000000001111;
int off = 0b0000000000000000;

digitalWrite(latchPin, LOW);  
shiftOut(dataPin, clockPin, LSBFIRST, on); 
shiftOut(dataPin, clockPin, LSBFIRST, on>>8); 
digitalWrite(latchPin, HIGH);
delay(100);
digitalWrite(latchPin, LOW);  
shiftOut(dataPin, clockPin, LSBFIRST, off); 
shiftOut(dataPin, clockPin, LSBFIRST, off>>8); 
digitalWrite(latchPin, HIGH);
delay(100);




}

void Setiap500ms(){
  Led = !Led;

}


void setup() {
  // Initialize Serial Monitor
  Serial.begin(115200);
    pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(LEDup, OUTPUT); 
  pinMode(LEDdn, OUTPUT);
  // Connect to Wi-Fi
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

// Initialize a NTPClient to get time
  timeClient.begin();
  timeClient.setTimeOffset(25200);
  wifinc();
  Timer500ms.attach_ms (500,Setiap500ms);  
}

void loop() {
  timeClient.update();
  unsigned long epochTime = timeClient.getEpochTime();
  Serial.print("Epoch Time: ");
  Serial.println(epochTime);
  
  int currentHour = timeClient.getHours();
  int currentMinute = timeClient.getMinutes();
 
  //Get a time structure
  struct tm *ptm = gmtime ((time_t *)&epochTime); 

  int monthDay = ptm->tm_mday;
  Serial.print("Month day: ");
  Serial.println(monthDay);

  int currentMonth = ptm->tm_mon+1;
  Serial.println("");
  printDigits(int(monthDay * 100 + currentMonth), int(currentHour * 100 + currentMinute) );  
  digitalWrite(LEDup,Led); //Led Detik
  digitalWrite(LEDdn,Led);
}
